<?
include_once("../lib/func_curl_error.php");

?>

<p>
Use this page to automatically verify your SnortSMS configuration. Below are the result of your current configuration test.
</p>


<?
$num = -1;
/*** Test config directory read/write ***/
$num++;
$test[$num]['name'] = "Configuration Directory (Read/Write)";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "You wil not be able to save your SnortSMS configuration.";
$test[$num]['solution'] = "Be sure the SnortSMS config directory is read/writeable by the web server:<BR>chmod 775 {webroot}/snortsms/conf<BR>chown :www {webroot}/snortsms/conf";
$pass = true;
$temp_file = $GBL['DOC_ROOT'] . "conf/SMS_test.tmp";
$test[$num]['info'] = "Config dir: " . $GBL['DOC_ROOT'] . "conf/";
if(!($handle = fopen($temp_file, "w") ))
	{
	$pass = false;
	}
else
	{
	if (fwrite($handle, "TEST") === FALSE)
		{
		$pass = false;
		}
	fclose($handle);
	}
if(!($handle = fopen($temp_file, "r") ))
	{
	$pass = false;
	}
else
	{
	$contents = "";
	while (!feof($handle))
		{
		$contents .= fread($handle, 4);
		}
	fclose($handle);
	unlink($temp_file);
	if($contents != "TEST")
		{
		$pass = false;
		}	
	}
if($pass != TRUE)
	{ $test[$num]['results'] = $pass; }



/*** Test temp directory read/write ***/
$num++;
$test[$num]['name'] = "Temporary Directory (Read/Write)";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "Effects Remote Agent responces and file snapshot importing.";
$test[$num]['solution'] = "Be sure your config directory is read/writeable by the web server.<BR>chmod 775 ".$GBL['tmpdir'];
$pass = true;
$temp_file = $GBL['tmpdir'] . "/SMS_test.tmp";
$test[$num]['info'] = "Temp dir: ".$GBL['tmpdir']."/";
if(!($handle = fopen($temp_file, "w") ))
	{
	$pass = false;
	}
else
	{
	if (fwrite($handle, "TEST") === FALSE)
		{
		$pass = false;
		}
	fclose($handle);
	}
if(!($handle = fopen($temp_file, "r") ))
	{
	$pass = false;
	}
else
	{
	$contents = "";
	while (!feof($handle))
		{
		$contents .= fread($handle, 4);
		}
	fclose($handle);
	unlink($temp_file);
	if($contents != "TEST")
		{
		$pass = false;
		}	
	}
if($pass != TRUE)
	{ $test[$num]['results'] = $pass; }


/*** Test CURL ***/
$num++;
$test[$num]['name'] = "curl (CLI mode)";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "SnortSMS will not be able to remotely connect to the sensor's remote agent nor automatically fetch the snort snapshot file.";
$test[$num]['solution'] = "Be sure you have installed curl and that the path is correct in 'Global Settings'.<BR>Current curl path: ".$GBL['curl'];
$pass = TRUE;
list($proto,$junk) = explode("/",$_SERVER['SERVER_PROTOCOL']);
$command = $GBL['curl']." -I $proto://localhost/";
$output = array();
exec($command,$output,$resultcode);
if($resultcode != 0)
	{
	$pass = false;
	}
else
	{
	$test[$num]['info'] = ""; foreach($output as $line) { $test[$num]['info'] .= $line . "<BR>\n"; }
	}
if($pass != TRUE)
	{ $test[$num]['results'] = $pass; }

/*** Test tar ***/
$num++;
$test[$num]['name'] = "tar";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "May affect SnortSMS's ability to import and decompress the snort snapshot file.";
$test[$num]['solution'] = "Be sure you have tar installed and that the path is correct in 'Global Settings'.<BR>Current tar path: ".$GBL['tar'];
$pass = TRUE;
$command = $GBL['tar']." -v";
$output = array();
exec($command,$output,$resultcode);
if($resultcode != 1)
	{
	$pass = false;
	}
else
	{
	$test[$num]['info'] = ""; foreach($output as $line) { $test[$num]['info'] .= $line . "<BR>\n"; }
	}
if($pass != TRUE)
	{ $test[$num]['results'] = $pass; }
	
/*** Test PHP CLI ***/
$num++;
$test[$num]['name'] = "php (CLI mode)";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "May affect SnortSMS's ability to import and decompress the snort snapshot file.";
$test[$num]['solution'] = "Be sure you have php CLI installed and that the path is correct in 'Global Settings'.<BR>Current php path: ".$GBL['php_path'];
$pass = TRUE;
$command = $GBL['php_path']." -v";
$output = array();
exec($command,$output,$resultcode);
if($resultcode != 1)
	{
	$pass = false;
	}
else
	{
	$test[$num]['info'] = ""; foreach($output as $line) { $test[$num]['info'] .= $line . "<BR>\n"; }
	}
if($pass != TRUE)
	{ $test[$num]['results'] = $pass; }

	
	

/*** Test PHP session support ***/
$extension_array = get_loaded_extensions();
$extensions = "";
foreach($extension_array as $item) { $extensions .= $item . " "; }
$num++;
$test[$num]['name'] = "php session support";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "May affect SnortSMS's ability to track session variables within the web interface.";
$test[$num]['solution'] = "Re-compile PHP with sesson support and/or add the 'session' module extension.";
if (!preg_match("/session/", $extensions, $matches))
	{ $test[$num]['results'] = FALSE; }

	
/*** Test PHP pcre support ***/
$num++;
$test[$num]['name'] = "php pcre support";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "SnortSMS will not be able to proccess Snort rules.";
$test[$num]['solution'] = "Re-compile PHP with sesson support and/or add the 'pcre' module extension.";
if (!preg_match("/pcre/", $extensions, $matches))
	{ $test[$num]['results'] = FALSE; }

	
	

/*** Test SnortSMS DB ***/
$num++;
$test[$num]['name'] = "SnortSMS Database availability (required)";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "SnortSMS will not funtion without this database.";
$test[$num]['solution'] = "Enter the correct configuration data (and credentials) for the SnortSMS database.";
$GBL["dbdsn"] = $GBL["dbtype"] . "://" . $GBL["dbuser"] . ":" . $GBL["dbpasswd"] . "@" . $GBL["dbhost"] . "/" . $GBL["dbname"];	// DSN String
$db = DB::connect($GBL["dbdsn"],FALSE);
if (DB::isError($db))
	{
	$test[$num]['results'] = FALSE;
	$test[$num]['impact'] = $db->getMessage() . " - ".$test[$num]['impact'];
	}
	
/*** Test SnortSMS DB version (schema) ***/


/*** Test Snort Event DB ***/
$num++;
$test[$num]['name'] = "Snort Event Database availability";
$test[$num]['results'] = TRUE;
$test[$num]['passed'] = "PASSED";
$test[$num]['info'] = "";
$test[$num]['failed'] = "FAILED";
$test[$num]['impact'] = "SnortSMS Alert Event Browser will not be available, which is used to view snort alerts generated by the sensors.";
$test[$num]['solution'] = "Enter the correct configuration data (and credentials) for the Snort Event database.";
$GBL["dbdsn_snort"] = $GBL["dbtype_snort"] . "://" . $GBL["dbuser_snort"] . ":" . $GBL["dbpasswd_snort"] . "@" . $GBL["dbhost_snort"] . "/" . $GBL["dbname_snort"];
$db_sa = DB::connect($GBL["dbdsn_snort"],false);
if (DB::isError($db_sa))
	{
	$test[$num]['results'] = FALSE;
	}
else
	{
	$num++;
	$test[$num]['name'] = "Snort Event Database modification";
	$test[$num]['results'] = TRUE;
	$test[$num]['passed'] = "PASSED";
	$test[$num]['info'] = "";
	$test[$num]['failed'] = "FAILED";
	$test[$num]['impact'] = "SnortSMS requires a small modification to the Snort Event Database in order to access it correctly.";
	$test[$num]['solution'] = "Please execute the following from your mysql database console:</B><BR>".
		"mysql> use {your snort db name};<BR>".
		"mysql> alter table event add column viewed tinyint (1);";
		
	$sql = "describe event viewed";
	$rsCheck = $db_sa->query($sql); if (DB::isError($rsCheck)) { die ($rsCheck->getDebugInfo());}
	$total = $rsCheck->numRows();
	
	if(!($total == 1))
		{
		$test[$num]['results'] = FALSE;
		}
	
	}








/*** Show the results ***/
?>
<BR>
<CENTER>
<table border="0" cellspacing="0" cellpadding="4" class="bg2">
<tr class="bg3">
<th>Test</th>
<th>Results</th>
<th>&nbsp;</th>
</tr>
<?
foreach($test as $item)
	{
	?>
	<tr>
	<td><b><?=$item['name']?></b></td>
	<?
	if($item['results'])
		{
		?>
		<td style="color:Green;"><B><?=$item['passed']?></B></td>
		<td><?=$item['info']?></td>
		<?
		}
	else
		{
		?>
		<td style="color:Red;"><B><?=$item['failed']?></B></td>
		<td><P><b>Impact:</b> <?=$item['impact']?></P><P><b>Solution:</b> <?=$item['solution']?></P></td>
		<?
		}
	?>
	</tr>
	<tr>
	<td colspan="3" class="bg4">&nbsp;</td>
	</tr>
	<?	
	}
?>


</tr>
<tr>
<td><b>Browser-side Java Script</b></td>

<script language="JavaScript 1.2" type="text/javascript">
if (window.focus) 
{ document.write("<td style=\"color:Green;\"><B>PASSED</B></td>");}

</SCRIPT>
<NOSCRIPT>
<td style="color:Red;"><B>FAILED</B></td>
</NOSCRIPT>

<td>
<NOSCRIPT>
Browser-side java scripting must be enabled.
</NOSCRIPT>
</td>

</tr>
</table>
</CENTER>
