<?php
/*
Fusebox Software License
Version 1.0

Copyright (c) 2001-2005 The Fusebox Corporation. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form or otherwise encrypted form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. The end-user documentation included with the redistribution, if any, must include the following acknowledgment:

"This product includes software developed by the Fusebox Corporation (http://www.fusebox.org/)."

Alternately, this acknowledgment may appear in the software itself, if and wherever such third-party acknowledgments normally appear.

4. The names "Fusebox" and "Fusebox Corporation" must not be used to endorse or promote products derived from this software without prior written (non-electronic) permission. For written permission, please contact fusebox@fusebox.org.

5. Products derived from this software may not be called "Fusebox", nor may "Fusebox" appear in their name, without prior written (non-electronic) permission of the Fusebox Corporation. For written permission, please contact fusebox@fusebox.org.

If one or more of the above conditions are violated, then this license is immediately revoked and can be re-instated only upon prior written authorization of the Fusebox Corporation.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FUSEBOX CORPORATION OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

--------------------------------------------------------------------------------

This software consists of voluntary contributions made by many individuals on behalf of the Fusebox Corporation. For more information on Fusebox, please see <http://www.fusebox.org/>.
*/

/*
<fusedoc fuse="fbx_SaveContent.php">
	<responsibilities>
		I am a custom class recreating the functionality of ColdFusion's CFSaveContent tag. The tag was originally released as cf_BodyContent by Steve Nelson. This class is required for PHP-Fusebox 3.0.
		Useage:
			$SC = new SaveContent();
				print "Some stuff.";
			$SaveContent = $SC->close();
		The variable $SaveContent now contains "Some stuff.", and nothing has been sent to the browser yet.  This functionality is essential to the core code in Fusebox 3, not to mention a pretty cool tool in general.
	</responsibilities>
	<history author="David Huyck" email="b@bombusbee.com" date="8 November 2001" type="Update">Added the function Module which mimics the behavior of CFModule (without the ability to include an "end tag").  Useage: Module("templateName.php", array("var1"=>"val1","var2"=>"val2","foo"=>"bar"))</history>
	<history author="David Huyck" email="b@bombusbee.com" date="25 March 2002" type="Update">Fixed a bug in the Location() function, and changed the simple META tag into a JavaScript redirect with the META as a noscript option.</history>
	<history author="David Huyck" email="b@bombusbee.com" date="1 April 2002" type="Update">Added a check to see if the SaveContent class is yet defined in the app.  Problems can occur when one app Modules() another app using a different root app.</history>
	<history author="David Huyck" email="b@bombusbee.com" date="26 April 2002" type="Update">Added some logic to the module method of the SaveContent class that chdir's to the directory we are Module()-ing to.  This fixes a bug where Moduling to a directory other than the current dir breaks the application.</history>
</fusedoc>
*/

if (!class_exists('SaveContent')) {
	class SaveContent {
		var $content;
		
		function SaveContent() {
			ob_start(); //start the output buffer
		}
		function clear() {
			ob_end_clean(); //clear buffer, end collection of content
							//without returning the contents of the buffer
		}
		function forward($location) {
			ob_end_clean(); //clear buffer, end collection of content
			header("Location: $location"); //forward to another page
			exit; //end the PHP processing
		}
		function close() {
			$buf = ob_get_contents(); //get stuff out of buffer to variable
			ob_end_clean(); //clear buffer, end collection of content
			return $buf; // return the contents of the buffer--
						 // requires that the calling template receives this value like so:
						 // $SaveContent = $SC->close();
		}
		
		function module($filePath, $attributes) {
			$isModule = true;
			$myPath = getcwd()."/";
			$aryPath = split("/", $filePath);
			$fileName = array_pop($aryPath);
			$modPath = join("/", $aryPath);
			chdir($myPath.$modPath);
			include($fileName);
			chdir($myPath);
			$this->content = $this->close();
		}
	}
	
	function Module($filePath, $attributes) { //Useage: Module("templateName.php", array("var1"=>"val1","var2"=>"val2","foo"=>"bar"))
		$Mod = new SaveContent;
		$Mod->module($filePath, $attributes);
		print $Mod->content;
	}
	
	function Location($URL, $addToken = 1) {
		$questionORamp = (strstr($URL, "?"))?"&":"?";
		$location = ($addToken && substr($URL, 0, 7) != "http://")?$URL.$questionORamp.$SID:$URL; //append the sessionID ($SID) by default
		ob_end_clean(); //clear buffer, end collection of content
		if(headers_sent()) {
			print('<script language="JavaScript"><!--
	location.replace("'.$location.'");
	// --></script>
	<noscript><META http-equiv="Refresh" content="0;URL='.$location.'"></noscript>');
		} else {
			header('Location: '.$location); //forward to another page
			exit; //end the PHP processing
		}
	}
}

?>